@echo off
setLocal EnableDelayedExpansion
IF "x%SCRIPT_DIR%" == "x" SET SCRIPT_DIR=%~dp0%
IF "!SCRIPT_DIR:~-1!"=="\" SET SCRIPT_DIR=!SCRIPT_DIR:~,-1!
SET BASE_SCRIPT_DIR=%SCRIPT_DIR%
REM get all args after first for passing extra args
set FIRSTARG=%1
set RESTVAR=
shift
:loop1
if "%1"=="" goto after_loop
set RESTVAR=%RESTVAR% %1
shift
goto loop1
:after_loop
if NOT "%FIRSTARG%" == "" goto RUNCOMMAND
goto MENU

REM FUNCTIONS FOR COMMANDS
REM *** start *** 
:start
cls
echo start
CD "%SCRIPT_DIR%\"
start bin\nginx.exe
goto %GOTONEXT%
::

REM *** stop *** 
:stop
cls
echo stop
CD "%SCRIPT_DIR%\"
CALL "%SCRIPT_DIR%\bin\nginx.exe" -s stop
goto %GOTONEXT%
::

REM *** reload *** 
:reload
cls
echo reload
CD "%SCRIPT_DIR%\"
CALL "%SCRIPT_DIR%\bin\nginx.exe" -s reload
goto %GOTONEXT%
::

REM *** restart *** 
:restart
cls
echo restart
CD "%SCRIPT_DIR%\"
start /wait bin\nginx.exe -s stop
start bin\nginx.exe
goto %GOTONEXT%
::

REM *** install-nginx *** 
:install-nginx
cls
echo install-nginx
CALL "%SCRIPT_DIR%\bin\service\"install-service.bat install
            CALL "%SCRIPT_DIR%\bin\service\"install-service.bat start
goto %GOTONEXT%
::

REM *** remove-nginx *** 
:remove-nginx
cls
echo remove-nginx
CALL "%SCRIPT_DIR%\bin\service\"install-service.bat uninstall
goto %GOTONEXT%
::

:MENU
SET GOTONEXT=PAUSEMENU
cls
SET SCRIPT_DIR=%BASE_SCRIPT_DIR%
CD %SCRIPT_DIR%
echo.
echo  NGINX Server
echo    usage: %~n0%~x0 ^[start^|stop^|reload^|restart^|install-nginx^|remove-nginx^]
echo.
echo    0 EXIT
echo    1 start (start the server)
echo    2 stop (stop the server)
echo    3 reload (reload the server)
echo    4 restart (restart the server)
echo    ************************************************************
echo    6 install-nginx (install the nginx webserver daemon)
echo    7 remove-nginx (remove the nginx webserver daemon)
echo.
echo.
set choice=
set /p choice=  Enter option number :
echo.
REM trim whitespace
for /f "tokens=* delims= " %%a in ("%choice%") do set choice=%%a
for /l %%a in (1,1,100) do if "!choice:~-1!"==" " set choice=!choice:~0,-1!
if '%choice%'=='0' goto BYE
if '%choice%'=='1' goto start
if '%choice%'=='2' goto stop
if '%choice%'=='3' goto reload
if '%choice%'=='4' goto restart
if '%choice%'=='6' goto install-nginx
if '%choice%'=='7' goto remove-nginx
::
echo.
echo.
echo "%choice%" is not a valid option - try again
echo.
pause
goto MENU
::
:RUNCOMMAND
SET GOTONEXT=BYE
if "%FIRSTARG%" == "start" goto start
if "%FIRSTARG%" == "stop" goto stop
if "%FIRSTARG%" == "reload" goto reload
if "%FIRSTARG%" == "restart" goto restart
if "%FIRSTARG%" == "separator" goto separator
if "%FIRSTARG%" == "install-nginx" goto install-nginx
if "%FIRSTARG%" == "remove-nginx" goto remove-nginx
echo Unknown option %FIRSTARG%
goto BYE
::
:PAUSEMENU
set choice=
echo       press any key ...
pause
goto MENU
::
:BYE
::
